Index: /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5192)
+++ /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5193)
@@ -1732,4 +1882,5 @@
         sum_thvx(i) = 0.
         sum_dth(i) = 0.
+        sum_half_dth(i) = 0.
         sum_dq(i) = 0.
         sum_dtdwn(i) = 0.
@@ -1744,17 +1895,46 @@
         av_dtdwn(i) = 0.
         av_dqdwn(i) = 0.
+
+        dthmin(i) = -delta_t_min
       END IF
     END DO
+    ! Potential temperatures and humidity
+    ! ----------------------------------------------------------
+
+    DO k = 1, klev
+      DO i = 1, klon
+        ! cc nrlmd       IF ( wk_adv(i)) THEN
+        IF (ok_qx_qw(i)) THEN
+          ! cc
+          rho(i, k) = p(i, k) / (RD * tb(i, k))
+          IF (k==1) THEN
+            rhoh(i, k) = ph(i, k) / (RD * tb(i, k))
+            zhh(i, k) = 0
+          ELSE
+            rhoh(i, k) = ph(i, k) * 2. / (RD * (tb(i, k) + tb(i, k - 1)))
+            zhh(i, k) = (ph(i, k) - ph(i, k - 1)) / (-rhoh(i, k) * RG) + zhh(i, k - 1)
+          END IF
+          thb(i, k) = tb(i, k) / ppi(i, k)
+          thx(i, k) = (tb(i, k) - deltatw(i, k) * sigmaw(i)) / ppi(i, k)
+          tx(i, k) = tb(i, k) - deltatw(i, k) * sigmaw(i)
+          qx(i, k) = qb(i, k) - deltaqw(i, k) * sigmaw(i)
+          dth(i, k) = deltatw(i, k) / ppi(i, k)
+        END IF
+      END DO
+    END DO
 
     ! Integrals (and wake top level number)
-    ! --------------------------------------
+    ! -----------------------------------------------------------
 
     ! Initialize sum_thvx to 1st level virt. pot. temp.
 
     DO i = 1, klon
-      IF (wk_adv(i)) THEN !!! nrlmd
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
         z(i) = 1.
         dz(i) = 1.
-        sum_thvx(i) = thx(i, 1)*(1.+epsim1*qx(i,1))*dz(i)
+        dz_half(i) = 1.
+        sum_thvx(i) = thx(i, 1) * (1. + epsim1 * qx(i, 1)) * dz(i)
         sum_dth(i) = 0.
       END IF
@@ -1763,16 +1943,24 @@
     DO k = 1, klev
       DO i = 1, klon
-        IF (wk_adv(i)) THEN !!! nrlmd
-          dz(i) = -(max(ph(i,k+1),ptop(i))-ph(i,k))/(rho(i,k)*RG)
+        ! cc nrlmd       IF ( wk_adv(i)) THEN
+        IF (ok_qx_qw(i)) THEN
+          ! cc
+          dz(i) = -(amax1(ph(i, k + 1), ptop(i)) - ph(i, k)) / (rho(i, k) * RG)
+          dz_half(i) = -(amax1(ph(i, k + 1), 0.5 * (ptop(i) + ph(i, 1))) - ph(i, k)) / (rho(i, k) * RG)
           IF (dz(i)>0) THEN
             z(i) = z(i) + dz(i)
-            sum_thx(i) = sum_thx(i) + thx(i, k)*dz(i)
-            sum_tx(i) = sum_tx(i) + tx(i, k)*dz(i)
-            sum_qx(i) = sum_qx(i) + qx(i, k)*dz(i)
-            sum_thvx(i) = sum_thvx(i) + thx(i, k)*(1.+epsim1*qx(i,k))*dz(i)
-            sum_dth(i) = sum_dth(i) + dth(i, k)*dz(i)
-            sum_dq(i) = sum_dq(i) + deltaqw(i, k)*dz(i)
-            sum_dtdwn(i) = sum_dtdwn(i) + dtdwn(i, k)*dz(i)
-            sum_dqdwn(i) = sum_dqdwn(i) + dqdwn(i, k)*dz(i)
+            sum_thx(i) = sum_thx(i) + thx(i, k) * dz(i)
+            sum_tx(i) = sum_tx(i) + tx(i, k) * dz(i)
+            sum_qx(i) = sum_qx(i) + qx(i, k) * dz(i)
+            sum_thvx(i) = sum_thvx(i) + thx(i, k) * (1. + epsim1 * qx(i, k)) * dz(i)
+            sum_dth(i) = sum_dth(i) + dth(i, k) * dz(i)
+            sum_dq(i) = sum_dq(i) + deltaqw(i, k) * dz(i)
+            sum_dtdwn(i) = sum_dtdwn(i) + dtdwn(i, k) * dz(i)
+            sum_dqdwn(i) = sum_dqdwn(i) + dqdwn(i, k) * dz(i)
+
+            dthmin(i) = min(dthmin(i), dth(i, k))
+          END IF
+          IF (dz_half(i)>0) THEN
+            sum_half_dth(i) = sum_half_dth(i) + dth(i, k) * dz_half(i)
           END IF
         END IF
@@ -1781,46 +1969,79 @@
 
     DO i = 1, klon
-      IF (wk_adv(i)) THEN !!! nrlmd
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
         hw0(i) = z(i)
       END IF
     END DO
 
-
     ! - WAPE and mean forcing computation
-    ! ---------------------------------------
-
-    ! ---------------------------------------
+    ! -------------------------------------------------------------
 
     ! Means
 
     DO i = 1, klon
-      IF (wk_adv(i)) THEN !!! nrlmd
-        av_thx(i) = sum_thx(i)/hw0(i)
-        av_tx(i) = sum_tx(i)/hw0(i)
-        av_qx(i) = sum_qx(i)/hw0(i)
-        av_thvx(i) = sum_thvx(i)/hw0(i)
-        av_dth(i) = sum_dth(i)/hw0(i)
-        av_dq(i) = sum_dq(i)/hw0(i)
-        av_dtdwn(i) = sum_dtdwn(i)/hw0(i)
-        av_dqdwn(i) = sum_dqdwn(i)/hw0(i)
-
-        wape(i) = -RG*hw0(i)*(av_dth(i)+epsim1*(av_thx(i)*av_dq(i) + &
-                              av_dth(i)*av_qx(i)+av_dth(i)*av_dq(i)))/av_thvx(i)
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
+        av_thx(i) = sum_thx(i) / hw0(i)
+        av_tx(i) = sum_tx(i) / hw0(i)
+        av_qx(i) = sum_qx(i) / hw0(i)
+        av_thvx(i) = sum_thvx(i) / hw0(i)
+        av_dth(i) = sum_dth(i) / hw0(i)
+        av_dq(i) = sum_dq(i) / hw0(i)
+        av_dtdwn(i) = sum_dtdwn(i) / hw0(i)
+        av_dqdwn(i) = sum_dqdwn(i) / hw0(i)
+
+        wape2(i) = -RG * hw0(i) * (av_dth(i) + epsim1 * (av_thx(i) * av_dq(i) + &
+                av_dth(i) * av_qx(i) + av_dth(i) * av_dq(i))) / av_thvx(i)
       END IF
     END DO
-
+    IF (CPPKEY_IOPHYS_WK) THEN
+      IF (.NOT.phys_sub) CALL iophys_ecrit('wape2_a', 1, 'wape2_a', 'J/kg', wape2)
+    END IF
+
+
+    ! Prognostic variable update
+    ! ------------------------------------------------------------
 
     ! Filter out bad wakes
 
+    IF (iflag_wk_check_trgl>=1) THEN
+      ! Check triangular shape of dth profile
+      DO i = 1, klon
+        IF (ok_qx_qw(i)) THEN
+          !! PRINT *,'wake, hw0(i), dthmin(i) ', hw0(i), dthmin(i)
+          !! PRINT *,'wake, 2.*sum_dth(i)/(hw0(i)*dthmin(i)) ', &
+          !!                2.*sum_dth(i)/(hw0(i)*dthmin(i))
+          !! PRINT *,'wake, sum_half_dth(i), sum_dth(i) ', &
+          !!                sum_half_dth(i), sum_dth(i)
+          IF ((hw0(i) < 1.) .OR. (dthmin(i) >= -delta_t_min)) THEN
+            wape2(i) = -1.
+            !! PRINT *,'wake, rej 1'
+          ELSE IF (iflag_wk_check_trgl==1.AND.abs(2. * sum_dth(i) / (hw0(i) * dthmin(i)) - 1.) > 0.5) THEN
+            wape2(i) = -1.
+            !! PRINT *,'wake, rej 2'
+          ELSE IF (abs(sum_half_dth(i)) < 0.5 * abs(sum_dth(i))) THEN
+            wape2(i) = -1.
+            !! PRINT *,'wake, rej 3'
+          END IF
+        END IF
+      END DO
+    END IF
+    IF (CPPKEY_IOPHYS_WK) THEN
+      IF (.NOT.phys_sub) CALL iophys_ecrit('wape2_b', 1, 'wape2_b', 'J/kg', wape2)
+    END IF
+
     DO k = 1, klev
       DO i = 1, klon
-        IF (wk_adv(i)) THEN !!! nrlmd
-          IF (wape(i)<0.) THEN
-            deltatw(i, k) = 0.
-            deltaqw(i, k) = 0.
-            dth(i, k) = 0.
-            d_deltatw2(i,k) = -deltatw0(i,k)
-            d_deltaqw2(i,k) = -deltaqw0(i,k)
-          END IF
+        ! cc nrlmd        IF ( wk_adv(i) .AND. wape2(i) .LT. 0.) THEN
+        IF (ok_qx_qw(i) .AND. wape2(i)<0.) THEN
+          ! cc
+          deltatw(i, k) = 0.
+          deltaqw(i, k) = 0.
+          dth(i, k) = 0.
+          d_deltatw2(i, k) = -deltatw0(i, k)
+          d_deltaqw2(i, k) = -deltaqw0(i, k)
         END IF
       END DO
@@ -1828,11 +2049,13 @@
 
     DO i = 1, klon
-      IF (wk_adv(i)) THEN !!! nrlmd
-        IF (wape(i)<0.) THEN
-          wape(i) = 0.
-          cstar(i) = 0.
+      ! cc nrlmd       IF ( wk_adv(i)) THEN
+      IF (ok_qx_qw(i)) THEN
+        ! cc
+        IF (wape2(i)<0.) THEN
+          wape2(i) = 0.
+          cstar2(i) = 0.
           hw(i) = hwmin
-!jyg<
-!!          sigmaw(i) = max(sigmad, sigd_con(i))
+          !jyg<
+          !!      sigmaw(i) = amax1(sigmad, sigd_con(i))
           sigmaw_targ = max(sigmad, sigd_con(i))
           d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
